attach-time field for volumes is not updated for detach volume

Bug #1056122 reported by Arathi on 2012-09-25
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
Low
Arathi
Folsom
Low
Chuck Short
nova (Ubuntu)
Undecided
Unassigned
Quantal
Undecided
Unassigned

Bug Description

attach-time field is not NULL for the volume in available state.

mysql> select id, attach_time, status from volumes; | grep available
+--------------------------------------+---------------------+-----------+
| id | attach_time | status |
+--------------------------------------+---------------------+-----------+
| e967d69f-c5e1-4114-8a77-016f6b2e892a | 2012-09-25 10:04:09 | available |
+--------------------------------------+---------------------+-----------+

Need to update attach-time field to NULL/NONE, if it is detached from an instance.

Changed in ceilometer:
assignee: nobody → Arathi (arathi-darshanam)
Julien Danjou (jdanjou) wrote :

IIRC this should be in Cinder, not Ceilometer?

affects: ceilometer → openstack-common
Arathi (arathi-darshanam) wrote :

For euca-describe-instances, if a instance is attached to volume, but attach_time filed is NULL, then '-' is appended to attach-time XML attribute.
Eg:
<ebs><status>in-use</status><deleteOnTermination>false</deleteOnTermination><volumeId>29</volumeId><attachTime>-</attachTime></ebs>

Can we replace '-' to ''(0 length string).

Arathi (arathi-darshanam) wrote :

For other attributes in XML content-type, if the value is null then '' is appended.
Eg:
In nova/api/ec2/cloud.py:CloudController._format_volume
<snip>
      if context.is_admin:
            # NOTE(dprince): project_id and host_id are unset w/ Cinder
            v['status'] = '%s (%s, %s, %s, %s)' % (
                volume['status'],
                volume.get('project_id', ''),
                volume.get('host', ''),
                instance_data,
                volume['mountpoint'])
<snip>

Changed in openstack-common:
status: New → In Progress
Changed in openstack-common:
status: In Progress → New
affects: openstack-common → nova
Changed in nova:
status: New → In Progress
Arathi (arathi-darshanam) wrote :

For reference changes are at: https://review.openstack.org/#/c/13691/

Vish Ishaya (vishvananda) wrote :

this fix is in, but can someone verify the proper value of the field in ec2? Is it '' ?

tags: added: folsom-backport-potential

Reviewed: https://review.openstack.org/13691
Committed: http://github.com/openstack/nova/commit/ee2dd66c9c2350d9c4aa4ae535daed7e8d72dfb3
Submitter: Jenkins
Branch: master

commit ee2dd66c9c2350d9c4aa4ae535daed7e8d72dfb3
Author: Arathi <email address hidden>
Date: Wed Sep 26 11:04:20 2012 +0530

    Updated code to update attach_time of a volume while detaching

    While detaching volume from an instance, attach_time of the
    volume is not updated. This task updates volume['attach_time']
    to NONE at detach_volume.

    Also modified the default value of XML attribute
    volume['attach_time'] '-' to ''(a 0 length string) to
    maintain consistency with existing code.

    Fixes bug: 1056122

    Change-Id: If56ceda6caab80fb803fcf194ed1dfb18808ec3a

Changed in nova:
status: In Progress → Fix Committed
Chuck Short (zulcss) on 2012-10-24
tags: removed: folsom-backport-potential
Thierry Carrez (ttx) on 2012-11-21
Changed in nova:
milestone: none → grizzly-1
status: Fix Committed → Fix Released
Changed in nova:
importance: Undecided → Low

Reviewed: https://review.openstack.org/14779
Committed: http://github.com/openstack/nova/commit/97649b88e90eb08dfd1ac2ba778251f7be39eb35
Submitter: Jenkins
Branch: stable/folsom

commit 97649b88e90eb08dfd1ac2ba778251f7be39eb35
Author: Arathi <email address hidden>
Date: Wed Sep 26 11:04:20 2012 +0530

    Updated code to update attach_time of a volume while detaching

    While detaching volume from an instance, attach_time of the
    volume is not updated. This task updates volume['attach_time']
    to NONE at detach_volume.

    Also modified the default value of XML attribute
    volume['attach_time'] '-' to ''(a 0 length string) to
    maintain consistency with existing code.

    Fixes bug: 1056122

    Change-Id: If56ceda6caab80fb803fcf194ed1dfb18808ec3a
    (cherry picked from commit ee2dd66c9c2350d9c4aa4ae535daed7e8d72dfb3)

Changed in nova (Ubuntu):
status: New → Fix Released
Changed in nova (Ubuntu Quantal):
status: New → Confirmed

Hello Arathi, or anyone else affected,

Accepted nova into quantal-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/nova/2012.2.1+stable-20121212-a99a802e-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in nova (Ubuntu Quantal):
status: Confirmed → Fix Committed
tags: added: verification-needed
Launchpad Janitor (janitor) wrote :
Download full text (8.3 KiB)

This bug was fixed in the package nova - 2012.2.1+stable-20121212-a99a802e-0ubuntu1

---------------
nova (2012.2.1+stable-20121212-a99a802e-0ubuntu1) quantal-proposed; urgency=low

  * Ubuntu updates:
    - debian/control: Ensure novaclient is upgraded with nova,
      require python-keystoneclient >= 1:2.9.0. (LP: #1073289)
    - d/p/avoid_setuptools_git_dependency.patch: Refresh.
  * Dropped patches, applied upstream:
    - debian/patches/CVE-2012-5625.patch: [a99a802]
  * Resynchronize with stable/folsom (b55014ca) (LP: #1085255):
    - [a99a802] create_lvm_image allocates dirty blocks (LP: #1070539)
    - [670b388] RPC exchange name defaults to 'openstack' (LP: #1083944)
    - [3ede373] disassociate_floating_ip with multi_host=True fails
      (LP: #1074437)
    - [22d7c3b] libvirt imagecache should handle shared image storage
      (LP: #1075018)
    - [e787786] Detached and deleted RBD volumes remain associated with insance
      (LP: #1083818)
    - [9265eb0] live_migration missing migrate_data parameter in Hyper-V driver
      (LP: #1066513)
    - [3d99848] use_single_default_gateway does not function correctly
      (LP: #1075859)
    - [65a2d0a] resize does not migrate DHCP host information (LP: #1065440)
    - [102c76b] Nova backup image fails (LP: #1065053)
    - [48a3521] Fix config-file overrides for nova-dhcpbridge
    - [69663ee] Cloudpipe in Folsom: no such option: cnt_vpn_clients
      (LP: #1069573)
    - [6e47cc8] DisassociateAddress can cause Internal Server Error
      (LP: #1080406)
    - [22c3d7b] API calls to dis-associate an auto-assigned floating IP should
      return proper warning (LP: #1061499)
    - [bd11d15] libvirt: if exception raised during volume_detach, volume state
      is inconsistent (LP: #1057756)
    - [dcb59c3] admin can't describe all images in ec2 api (LP: #1070138)
    - [78de622] Incorrect Exception raised during Create server when metadata
      over 255 characters (LP: #1004007)
    - [c313de4] Fixed IP isn't released before updating DHCP host file
      (LP: #1078718)
    - [f4ab42d] Enabling Return Reservation ID with XML create server request
      returns no body (LP: #1061124)
    - [3db2a38] 'BackupCreate' should accept rotation parameter greater than or
      equal to zero (LP: #1071168)
    - [f7e5dde] libvirt reboot sometimes fails to reattach volumes
      (LP: #1073720)
    - [ff776d4] libvirt: detaching volume may fail while terminating other
      instances on the same host concurrently (LP: #1060836)
    - [85a8bc2] Used instance uuid rather than id in remove-fixed-ip
    - [42a85c0] Fix error on invalid delete_on_termination value
    - [6a17579] xenapi migrations fail w/ swap (LP: #1064083)
    - [97649b8] attach-time field for volumes is not updated for detach volume
      (LP: #1056122)
    - [8f6a718] libvirt: rebuild is not using kernel and ramdisk associated with
      the new image (LP: #1060925)
    - [fbe835f] live-migration and volume host assignement (LP: #1066887)
    - [c2a9150] typo prevents volume_tmp_dir flag from working (LP: #1071536)
    - [93efa21] Instances deleted during spawn leak network allocations
      (LP: #1068716)
    - [ebabd02] After restartin...

Read more...

Changed in nova (Ubuntu Quantal):
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2013-04-04
Changed in nova:
milestone: grizzly-1 → 2013.1
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers